#include "pingpong.hpp"

PingPong::PingPong(int x, int y) :
	Icon(x, y, x + PINGPONG_WIDTH, y + PINGPONG_HEIGHT)
{
	/* start the object moving toward upper right */
	x_direction = 1;
	y_direction = 1;
}

void PingPong::Display()
{
	Paint(WHITE);
}

void PingPong::Erase()
{
	Paint(BLACK);
}

void PingPong::Paint(COLOR_TYPE color)
{
	BOX_TYPE box;
	box.x1 = x1;
	box.y1 = y1;
	box.x2 = x1 + PINGPONG_WIDTH;
	box.y2 = y1 + PINGPONG_HEIGHT;
	GraphicsHandler->DrawBox(color, SOLID_LINE, &box);
}

void PingPong::Update()
{
	int x, y;

	// erase the old box;
	Erase();

	// move the box
	x1 += x_direction;
	if ( (x1 < 1) || (x1 + PINGPONG_WIDTH > WORK_PAGE_X2) )
	  x_direction = -x_direction;

	y1 += y_direction;
	if ( (y1 < 1) || 
	   (y1 + PINGPONG_HEIGHT > SCREEN_TITLE_Y1 - 2) )
	  y_direction = -y_direction;

	// show the new location
	Display();
}
